%% Point operations
A = imread('cameraman.tif'); % example grayscale image

threshold1 = 120; % custom threshold value
threshold2 = 200; % custom threshold value
A_bw1 = A > threshold1;
imshowpair(A,A_bw1, 'montage')
A_bw2 = A > threshold2;
figure,
imshowpair(A,A_bw2, 'montage')

complement=255-A; %image negatives
imshow(complement)

%%
%gamma transformation of images
I = imread('woman.jpg');
J1 = imadjust(I,[],[],3);
J2 = imadjust(I,[],[],1);
J3 = imadjust(I,[],[],0.4);
imshow(J1);
figure, imshow(J2);
figure, imshow(J3);
%%
%Logarithmic Transformations
I=imread('tire.tif');
imshow(I)
I2=im2double(I);
J=1*log(1+I2);
J2=2*log(1+I2);
J3=5*log(1+I2);
figure, imshow(J)
figure, imshow(J2)
figure, imshow(J3)

%%
%Contrast stretching
I = imread('pout.tif');
figure
J = imadjust(I,stretchlim(I),[]);
figure
imshowpair(I,J,'montage')

%% Histogram equalization
img = imread('image.jpg');
imhist(img);
img_eq = histeq(img); imshow(img_eq);
imshowpair(img, img_eq, 'montage')
title('Before                                   After the histogram equalization')
%The histogram after the histogram equalization:
imhist(histeq(img)); 
%%
%Enhancing contrast using imadjust()
img = imread('image.jpg');
img_adj = imadjust(img, [0.4,0.86],[0.0,1.0]);
imshowpair(img,img_adj, 'montage')
title('Before                                          After Enhancing contrast')
figure;
hold on;
imhist(img);
imhist(img_adj);
hold off;

%% 
%%Histogram Specification

input_image= imread('office_2.jpg');   % Dark Image
ref = imread('office_4.jpg');   % Reference image
imshowpair(input_image,ref, 'montage')
% Separate input images color channel
input_image_r = input_image(:,:,1);
input_image_g = input_image(:,:,2);
input_image_b = input_image(:,:,3);

imgr2 = ref(:,:,1);
imgg2 = ref(:,:,2);
imgb2 = ref(:,:,3);

% Compute inputs histogram
Hnimgr = imhist(input_image_r);
Hnimgg = imhist(input_image_g);
Hnimgb = imhist(input_image_b);

% Compute references histogram
Hnimgr2 = imhist(imgr2);
Hnimgg2 = imhist(imgg2);
Hnimgb2 = imhist(imgb2);

% Histogram specification, using image reference
outr = histeq(input_image_r,Hnimgr2);
outg = histeq(input_image_g,Hnimgg2);
outb = histeq(input_image_b,Hnimgb2);

histsp(:,:,1) = outr;
histsp(:,:,2) = outg;
histsp(:,:,3) = outb;

% Plot histogram & Display Image
%Show Image
figure;
subplot(221);imshow(ref);title('Reference Image');
subplot(222);imshow(input_image);title('Input Image');
subplot(224);imshow(histsp);title('Result Image');













